
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_DEMTreatment_MSG_LIB_H
#define MPC_DEMTreatment_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "MPC_DEMTreatmentType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  MPC_DEMTREATMENT_MBOX_NAME                  genomInstanceName("MPC_DEMTreatment")

#define  MPC_DEMTREATMENT_MAX_RQST_SIZE              256

#define  MPC_DEMTREATMENT_MBOX_RQST_SIZE       \
 (BUF_SIZE(MPC_DEMTREATMENT_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  MPC_DEMTREATMENT_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  MPC_DEMTREATMENT_MAX_REPLY_SIZE             8

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  MPC_DEMTREATMENT_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(MPC_DEMTREATMENT_MAX_REPLY_SIZE) \
   + BUF_SIZE(MPC_DEMTREATMENT_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define MPC_DEMTREATMENT_INIT_RQST 0
#define MPC_DEMTREATMENT_COMPUTE_DISTMAP_RQST 1
#define MPC_DEMTREATMENT_START_DEMLOG_RQST 2
#define MPC_DEMTREATMENT_STOP_DEMLOG_RQST 3
#define MPC_DEMTREATMENT_MERGE_DEMLOG_RQST 4
#define MPC_DEMTREATMENT_CLEAR_DEMLOG_RQST 5
#define MPC_DEMTREATMENT_SAVE_DEM_RQST 6
#define MPC_DEMTREATMENT_SETDISPLAYTIMEROPTION_RQST 7
#define MPC_DEMTREATMENT_START_DEMTIMER_RQST 8
#define MPC_DEMTREATMENT_STOP_DEMTIMER_RQST 9
#define MPC_DEMTREATMENT_ABORT_RQST 10


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS MPC_DEMTreatmentClientInit (CLIENT_ID *pClientId);

STATUS MPC_DEMTreatmentClientEnd (CLIENT_ID clientId);

int MPC_DEMTreatmentAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int MPC_DEMTreatmentAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int MPC_DEMTreatmentAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS MPC_DEMTreatmentInitRqstSend (CLIENT_ID clientId, int *pRqstId,
					 DT_INIT_I *(in_Init_I),
					 int replyTimeOut);

extern int MPC_DEMTreatmentInitReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_DEMTreatmentInitRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					DT_INIT_I *(in_Init_I), 
					
					int *activity, int *bilan);

extern int MPC_DEMTreatmentInitRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					DT_INIT_I *(in_Init_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_DEMTreatmentCompute_DistMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 BUILD_DISTMAP_I *(in_BuildDistMap_I),
					 int replyTimeOut);

extern int MPC_DEMTreatmentCompute_DistMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_DEMTreatmentCompute_DistMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					BUILD_DISTMAP_I *(in_BuildDistMap_I), 
					
					int *activity, int *bilan);

extern int MPC_DEMTreatmentCompute_DistMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					BUILD_DISTMAP_I *(in_BuildDistMap_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_DEMTreatmentStart_DEMLogRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int MPC_DEMTreatmentStart_DEMLogReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_DEMTreatmentStart_DEMLogRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS MPC_DEMTreatmentStop_DEMLogRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int MPC_DEMTreatmentStop_DEMLogReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_DEMTreatmentStop_DEMLogRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS MPC_DEMTreatmentMerge_DEMLogRqstSend (CLIENT_ID clientId, int *pRqstId,
					 MERGE_DEMLOG_I *(in_Merge_DEMLog_I),
					 int replyTimeOut);

extern int MPC_DEMTreatmentMerge_DEMLogReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_DEMTreatmentMerge_DEMLogRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					MERGE_DEMLOG_I *(in_Merge_DEMLog_I), 
					
					int *activity, int *bilan);

extern int MPC_DEMTreatmentMerge_DEMLogRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					MERGE_DEMLOG_I *(in_Merge_DEMLog_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_DEMTreatmentClear_DEMLogRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int MPC_DEMTreatmentClear_DEMLogReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_DEMTreatmentClear_DEMLogRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int MPC_DEMTreatmentClear_DEMLogRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS MPC_DEMTreatmentSave_DEMRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SAVE_DEM_I *(in_Save_DEM_I),
					 int replyTimeOut);

extern int MPC_DEMTreatmentSave_DEMReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int MPC_DEMTreatmentSave_DEMRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SAVE_DEM_I *(in_Save_DEM_I), 
					
					int *activity, int *bilan);

extern int MPC_DEMTreatmentSave_DEMRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SAVE_DEM_I *(in_Save_DEM_I), 
					
					int *activity,
					int *bilan);




extern STATUS MPC_DEMTreatmentSetDisplayTimerOptionRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 int *(in_display_time),
					 int replyTimeOut);

int MPC_DEMTreatmentSetDisplayTimerOptionReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_DEMTreatmentSetDisplayTimerOptionRqstAndRcv (CLIENT_ID clientId, 
				 int *(in_display_time), 
				 
				 int *bilan);




extern STATUS MPC_DEMTreatmentStart_DEMTimerRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int MPC_DEMTreatmentStart_DEMTimerReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_DEMTreatmentStart_DEMTimerRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS MPC_DEMTreatmentStop_DEMTimerRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int MPC_DEMTreatmentStop_DEMTimerReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int MPC_DEMTreatmentStop_DEMTimerRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* MPC_DEMTreatment_MSG_LIB_H */

