
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * MPC_DEMTreatmentType.h:     La SDI_F de MPC_DEMTreatment
 *
 * Utilise par le module et par les clients
 * (inclut dans MPC_DEMTreatmentMsgLib.h et MPC_DEMTreatmentPosterLib.h)
 * 
 */

#ifndef MPC_DEMTreatment_TYPE_H
#define MPC_DEMTreatment_TYPE_H

#include "genom/modules.h"
#include "MPC_DEMTreatmentError.h"

/* Nombre de tache d'execution de ce module */
#define MPC_DEMTREATMENT_NB_EXEC_TASK                   (1)


#endif
#ifndef MPC_DEMTreatment_TYPE1_H
#define MPC_DEMTreatment_TYPE1_H

#include "/opt/openrobots/include/genPos/genPosStruct.h"
#include "/opt/openrobots/include/pom/pomStruct.h"
#include "/opt/openrobots/include/dtm/dtmStruct.h"
#include "MPC_DEMTreatment-Struct.h"

/*
 * Structure de donnees interne
 */
typedef struct MPC_DEMTTT_STR {
	DIST_OBS_MAP distObsMap;
	int timer_started;
	float DT_slopeMapDist;
	float DT_thresSlope;
	float DT_thresVarSlope;
	float DT_safeDist;
	int DT_unkwnIsObs;
	DT_INIT_I Init_I;
	BUILD_DISTMAP_I BuildDistMap_I;
	MERGE_DEMLOG_I Merge_DEMLog_I;
	SAVE_DEM_I Save_DEM_I;
	int logDEM;
	int display_time;
	BUILD_DISTMAP_I Compute_DistMapInput[20];
} MPC_DEMTTT_STR;


#endif

