
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MPC_DEMTreatment_TCLSERV_CLIENT_MSG_LIB_H
#define MPC_DEMTreatment_TCLSERV_CLIENT_MSG_LIB_H

#include <server/MPC_DEMTreatmentType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int MPC_DEMTreatmentTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int MPC_DEMTreatmentTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int MPC_DEMTreatmentTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 DT_INIT_I *(in_Init_I) 
		);

int MPC_DEMTreatmentTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_DEMTreatmentTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				DT_INIT_I *(in_Init_I) ,
				
				int *bilan);

int MPC_DEMTreatmentTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					DT_INIT_I *(in_Init_I) ,
					
					int *bilan);




int MPC_DEMTreatmentTclservClientCompute_DistMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 BUILD_DISTMAP_I *(in_BuildDistMap_I) 
		);

int MPC_DEMTreatmentTclservClientCompute_DistMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_DEMTreatmentTclservClientCompute_DistMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				BUILD_DISTMAP_I *(in_BuildDistMap_I) ,
				
				int *bilan);

int MPC_DEMTreatmentTclservClientCompute_DistMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					BUILD_DISTMAP_I *(in_BuildDistMap_I) ,
					
					int *bilan);




int MPC_DEMTreatmentTclservClientStart_DEMLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int MPC_DEMTreatmentTclservClientStart_DEMLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_DEMTreatmentTclservClientStart_DEMLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int MPC_DEMTreatmentTclservClientStop_DEMLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int MPC_DEMTreatmentTclservClientStop_DEMLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_DEMTreatmentTclservClientStop_DEMLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int MPC_DEMTreatmentTclservClientMerge_DEMLogRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 MERGE_DEMLOG_I *(in_Merge_DEMLog_I) 
		);

int MPC_DEMTreatmentTclservClientMerge_DEMLogReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_DEMTreatmentTclservClientMerge_DEMLogRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				MERGE_DEMLOG_I *(in_Merge_DEMLog_I) ,
				
				int *bilan);

int MPC_DEMTreatmentTclservClientMerge_DEMLogRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					MERGE_DEMLOG_I *(in_Merge_DEMLog_I) ,
					
					int *bilan);




int MPC_DEMTreatmentTclservClientClear_DEMLogRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int MPC_DEMTreatmentTclservClientClear_DEMLogReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_DEMTreatmentTclservClientClear_DEMLogRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int MPC_DEMTreatmentTclservClientClear_DEMLogRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int MPC_DEMTreatmentTclservClientSave_DEMRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SAVE_DEM_I *(in_Save_DEM_I) 
		);

int MPC_DEMTreatmentTclservClientSave_DEMReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int MPC_DEMTreatmentTclservClientSave_DEMRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SAVE_DEM_I *(in_Save_DEM_I) ,
				
				int *bilan);

int MPC_DEMTreatmentTclservClientSave_DEMRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SAVE_DEM_I *(in_Save_DEM_I) ,
					
					int *bilan);




int MPC_DEMTreatmentTclservClientSetDisplayTimerOptionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 int *(in_display_time)
		);

int MPC_DEMTreatmentTclservClientSetDisplayTimerOptionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_DEMTreatmentTclservClientSetDisplayTimerOptionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 int *(in_display_time) ,
				 
				 int *bilan);




int MPC_DEMTreatmentTclservClientStart_DEMTimerRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int MPC_DEMTreatmentTclservClientStart_DEMTimerReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_DEMTreatmentTclservClientStart_DEMTimerRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int MPC_DEMTreatmentTclservClientStop_DEMTimerRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int MPC_DEMTreatmentTclservClientStop_DEMTimerReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int MPC_DEMTreatmentTclservClientStop_DEMTimerRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* MPC_DEMTreatmentTCLSERV_CLIENT_MSG_LIB_H */

