
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] MPC_DEMTreatmentInstall] >= 0 } {
    interp expose {} MPC_DEMTreatmentInstall
}

proc ::MPC_DEMTreatmentInstall { name } {
    foreach rqst { "Init" "Compute_DistMap" "Start_DEMLog" "Stop_DEMLog" "Merge_DEMLog" "Clear_DEMLog" "Save_DEM" "SetDisplayTimerOption" "Start_DEMTimer" "Stop_DEMTimer" "DistObsMapdistObsMapPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} MPC_DEMTreatment$rqst $name
    }
}

interp hide {} MPC_DEMTreatmentInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentInit] >= 0 } {
    interp expose {} MPC_DEMTreatmentInit
}
if { [lsearch [interp hidden] MPC_DEMTreatmentInitFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentInitFormatOutput
}

proc ::MPC_DEMTreatmentInit { name args } {
    set format {}
    lappend format [list string "Init_I.demPoster" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Initializes the MPC DEM treatment module" \
	"DT_INIT_I\n| char demPoster\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentInit
interp hide {} MPC_DEMTreatmentInitFormatOutput





# Compute_DistMap ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentCompute_DistMap] >= 0 } {
    interp expose {} MPC_DEMTreatmentCompute_DistMap
}
if { [lsearch [interp hidden] MPC_DEMTreatmentCompute_DistMapFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentCompute_DistMapFormatOutput
}

proc ::MPC_DEMTreatmentCompute_DistMap { name args } {
    set format {}
    lappend format [list float "BuildDistMap_I.slopeMapDist" 0.0 ]
    lappend format [list float "BuildDistMap_I.thresSlope" 0.0 ]
    lappend format [list float "BuildDistMap_I.thresVarSlope" 0.0 ]
    lappend format [list float "BuildDistMap_I.safeDist" 0.0 ]
    lappend format [list int "BuildDistMap_I.unkwnIsObs" 0 ]

    return [ ::cs::rqstSend "${name}" "Compute_DistMap" \
	"Builds a single the distance to obstacle map from the dtmP3dPoster" \
	"BUILD_DISTMAP_I\n| float slopeMapDist\n| float thresSlope\n| float thresVarSlope\n| float safeDist\n| int unkwnIsObs\n" \
	5 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentCompute_DistMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentCompute_DistMap
interp hide {} MPC_DEMTreatmentCompute_DistMapFormatOutput





# Start_DEMLog ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentStart_DEMLog] >= 0 } {
    interp expose {} MPC_DEMTreatmentStart_DEMLog
}
if { [lsearch [interp hidden] MPC_DEMTreatmentStart_DEMLogFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentStart_DEMLogFormatOutput
}

proc ::MPC_DEMTreatmentStart_DEMLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Start_DEMLog" \
	"Start to log DEMs" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentStart_DEMLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentStart_DEMLog
interp hide {} MPC_DEMTreatmentStart_DEMLogFormatOutput





# Stop_DEMLog ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentStop_DEMLog] >= 0 } {
    interp expose {} MPC_DEMTreatmentStop_DEMLog
}
if { [lsearch [interp hidden] MPC_DEMTreatmentStop_DEMLogFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentStop_DEMLogFormatOutput
}

proc ::MPC_DEMTreatmentStop_DEMLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop_DEMLog" \
	"Stop to log DEMs" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentStop_DEMLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentStop_DEMLog
interp hide {} MPC_DEMTreatmentStop_DEMLogFormatOutput





# Merge_DEMLog ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentMerge_DEMLog] >= 0 } {
    interp expose {} MPC_DEMTreatmentMerge_DEMLog
}
if { [lsearch [interp hidden] MPC_DEMTreatmentMerge_DEMLogFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentMerge_DEMLogFormatOutput
}

proc ::MPC_DEMTreatmentMerge_DEMLog { name args } {
    set format {}
    lappend format [list string "Merge_DEMLog_I.filename" "" ]

    return [ ::cs::rqstSend "${name}" "Merge_DEMLog" \
	"Merge every logged DEMs and save the global DEM into an output file" \
	"MERGE_DEMLOG_I\n| char filename\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentMerge_DEMLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentMerge_DEMLog
interp hide {} MPC_DEMTreatmentMerge_DEMLogFormatOutput





# Clear_DEMLog ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentClear_DEMLog] >= 0 } {
    interp expose {} MPC_DEMTreatmentClear_DEMLog
}
if { [lsearch [interp hidden] MPC_DEMTreatmentClear_DEMLogFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentClear_DEMLogFormatOutput
}

proc ::MPC_DEMTreatmentClear_DEMLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Clear_DEMLog" \
	"Clear the DEM log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentClear_DEMLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentClear_DEMLog
interp hide {} MPC_DEMTreatmentClear_DEMLogFormatOutput





# Save_DEM ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentSave_DEM] >= 0 } {
    interp expose {} MPC_DEMTreatmentSave_DEM
}
if { [lsearch [interp hidden] MPC_DEMTreatmentSave_DEMFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentSave_DEMFormatOutput
}

proc ::MPC_DEMTreatmentSave_DEM { name args } {
    set format {}
    lappend format [list string "Save_DEM_I.filename" "" ]

    return [ ::cs::rqstSend "${name}" "Save_DEM" \
	"Save the current DEM into an output file" \
	"SAVE_DEM_I\n| char filename\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentSave_DEMFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentSave_DEM
interp hide {} MPC_DEMTreatmentSave_DEMFormatOutput





# SetDisplayTimerOption ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentSetDisplayTimerOption] >= 0 } {
    interp expose {} MPC_DEMTreatmentSetDisplayTimerOption
}
if { [lsearch [interp hidden] MPC_DEMTreatmentSetDisplayTimerOptionFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentSetDisplayTimerOptionFormatOutput
}

proc ::MPC_DEMTreatmentSetDisplayTimerOption { name args } {
    set format {}
    lappend format [list int "display_time" 0 ]

    return [ ::cs::rqstSend "${name}" "SetDisplayTimerOption" \
	"Set the option to display the module timer" \
	"int display_time\n" \
	1 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentSetDisplayTimerOptionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentSetDisplayTimerOption
interp hide {} MPC_DEMTreatmentSetDisplayTimerOptionFormatOutput





# Start_DEMTimer ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentStart_DEMTimer] >= 0 } {
    interp expose {} MPC_DEMTreatmentStart_DEMTimer
}
if { [lsearch [interp hidden] MPC_DEMTreatmentStart_DEMTimerFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentStart_DEMTimerFormatOutput
}

proc ::MPC_DEMTreatmentStart_DEMTimer { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Start_DEMTimer" \
	"Start the DEM timer" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentStart_DEMTimerFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentStart_DEMTimer
interp hide {} MPC_DEMTreatmentStart_DEMTimerFormatOutput





# Stop_DEMTimer ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentStop_DEMTimer] >= 0 } {
    interp expose {} MPC_DEMTreatmentStop_DEMTimer
}
if { [lsearch [interp hidden] MPC_DEMTreatmentStop_DEMTimerFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentStop_DEMTimerFormatOutput
}

proc ::MPC_DEMTreatmentStop_DEMTimer { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop_DEMTimer" \
	"Stop the DEM timer" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::MPC_DEMTreatmentStop_DEMTimerFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentStop_DEMTimer
interp hide {} MPC_DEMTreatmentStop_DEMTimerFormatOutput





# DistObsMapdistObsMap ----------------------------------------------------------

if { [lsearch [interp hidden] MPC_DEMTreatmentDistObsMapdistObsMapPosterRead] >= 0 } {
    interp expose {} MPC_DEMTreatmentDistObsMapdistObsMapPosterRead
}
if { [lsearch [interp hidden] MPC_DEMTreatmentDistObsMapdistObsMapPosterFormatOutput] >= 0 } {
    interp expose {} MPC_DEMTreatmentDistObsMapdistObsMapPosterFormatOutput
}

proc ::MPC_DEMTreatmentDistObsMapdistObsMapPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "DistObsMapdistObsMap" \
	"DIST_OBS_MAP\n| int dimX\n| int dimY\n| float xOrigin\n| float yOrigin\n| float xScale\n| float yScale\n| int cellState\[250\]\[250\]\n| POS_CELL_XY\n| | int x\n| | int y\n| float thresSlope\n| float thresVarSlope\n| float safeDist\n| float padding\n" \
	$args ]
}


proc ::MPC_DEMTreatmentDistObsMapdistObsMapPosterFormatOutput { list } {
    set format { {} status { } { distObsMap { } dimX { } dimY { } xOrigin { } yOrigin { } xScale { } yScale { 250 250 } cellState { 250 250 } { dist { } x { } y } { } thresSlope { } thresVarSlope { } safeDist { } padding } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} MPC_DEMTreatmentDistObsMapdistObsMapPosterRead
interp hide {} MPC_DEMTreatmentDistObsMapdistObsMapPosterFormatOutput


